// u3a2_binaerzahl.cpp : Ausgabe eines unsigned char im Binaerformat
//
// Autor: C. Niederberger, ETH Zurich, 2002

#include <iostream>
using namespace std;

// diese Funktion gibt die Binaerstelle an Position 'position' eines 
// unsigned chars 'number' aus
void binaer_i(unsigned char number, unsigned char position)
{
  // teste das Bit an Position 'position'
  if ((number & (1 << position))!=0)
    {
      // falls das position-te Bit nicht Null ist
      cout << '1';
    }
  else
    {
      // falls das position-te Bit Null ist
      cout << '0';
    }
}

// diese Funktion gibt alle Stellen eines unsigned chars 'number' im 
// Binaerformat aus und verwendet keine Schleife
void binaer_ausgabe(unsigned char number)
{
  // ausgabe text
  cout << "ohne Schleife: dezimal: " << (int)number << "; binaer: ";
  // ausgabe erfolgt "rckwrts" !
  binaer_i(number, 7);
  binaer_i(number, 6);
  binaer_i(number, 5);
  binaer_i(number, 4);
  binaer_i(number, 3);
  binaer_i(number, 2);
  binaer_i(number, 1);
  binaer_i(number, 0);
  // und eine neue Zeile
  cout << endl;
}

// diese Funktion gibt alle Stellen eines unsigned chars 'number' im 
// Binaerformat aus und verwendet eine for Schleife
void binaer_ausgabe_schleife(unsigned char number)
{
  // der Text
  cout << "mit Schleife:  dezimal: " << (int)number << "; binaer: " ;
  // die Schleife
  for (int pos=7; pos>=0; pos--)
    {
      binaer_i(number, pos);
    }
  // der Zeilenumbruch
  cout << endl;
}

// das Hauptprogramm
int main()
{
  // die Inputzahl muss ein int sein wegen cin!
  int input;

  // Eingabe
  cout << "Geben sie eine Zahl zwischen 0 und 255 an > ";
  cin >> input;

  // Gltigkeitsbereich testen
  if ((input>=0) && (input<256))
    {
      // dann geht auch der cast auf einen unsigned char
      unsigned char a = (unsigned char)input;
      // und Aufruf der Ausgabefunktion
      binaer_ausgabe(a);
      // oder der Ausgabefunktion mit Schleife
      binaer_ausgabe_schleife(a);
    } else {
      // Fehlermeldung
      cout << "Der Wert liegt nicht im geforderten Intervall. " << endl;
    }
  // Fertig
  return 0;    
}

